package com.android.launcher3.folder

import android.view.View
import com.android.launcher3.Folder
import com.android.launcher3.ShortcutInfo
import com.android.launcher3.Workspace
import com.teslacoilsw.launcher.CellIconSizeSpecs

interface FolderContentView : Workspace.ItemContainer {
    fun setFolder(folder: Folder?)
    fun setCellSpecs(cellSpecs: CellIconSizeSpecs)
    fun setCellDimensions(cellWidthPx: Int, cellHeightPx: Int)
    fun setGridSize(x: Int, y: Int)
    fun setInvertIfRtl(isRtl: Boolean)
    fun bindItems(sortedChildren: List<ShortcutInfo>)

    fun getDesiredWidth(columns: Int): Int
    fun getDesiredHeight(rows: Int): Int

    fun getDesiredHeight(): Int
    fun getDesiredWidth(): Int

    fun setFixedSize(width: Int, height: Int)

    fun getCellSpecs(): CellIconSizeSpecs

    fun setFocusOnFirstChild()

    fun realTimeReorder(emptyRank: Int, target: Int)
    fun findNearestArea(pixelX: Int, pixelY: Int): Int

    fun arrangeChildren(list: List<View?>, count: Int = list.size, saveChanges: Boolean = true)

    val itemCount: Int

    fun setupContentDimensions(list: List<View>, count: Int)

    fun getLastItem(): View?

    fun rankOnCurrentPage(rank: Int): Boolean = true

    fun completePendingPageChanges() {}
    fun createAndAddViewForRank(item: ShortcutInfo, rank: Int): View

    fun addViewForRank(view: View, item: ShortcutInfo, rank: Int): View?

    fun allocateRankForNewItem(): Int

    fun removeItem(view: View)

}