package com.teslacoilsw.kotlin

import android.app.Activity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingComponent
import androidx.databinding.DataBindingUtil
import androidx.databinding.ViewDataBinding

inline fun <T : ViewDataBinding> LayoutInflater.bind(layoutId: Int, parent: ViewGroup?, attachToParent: Boolean = parent != null, bindingComponent: DataBindingComponent? = null) =
    DataBindingUtil.inflate<T>(this, layoutId, parent, attachToParent, bindingComponent)

inline fun <T: ViewDataBinding> Activity.bindContentView(layoutId: Int, bindingComponent: DataBindingComponent? = null) =
        DataBindingUtil.setContentView<T>(this, layoutId, bindingComponent)

inline fun <T: ViewDataBinding> View.bind(bindingComponent: DataBindingComponent? = null) =
        DataBindingUtil.bind<T>(this, bindingComponent)!!