package com.teslacoilsw.kotlin

import android.content.Context
import android.util.DisplayMetrics
import android.util.TypedValue

fun Context.dp(dimenDp: Int): Int = resources.displayMetrics.dp(dimenDp)
fun Context.dp(dimenDp: Float): Int = resources.displayMetrics.dp(dimenDp)
fun Context.sp(dimenSp: Float): Float = resources.displayMetrics.sp(dimenSp)

fun DisplayMetrics.dp(dimenDp: Int): Int {
    val f = dimenDp * density
    val res = (f + 0.5f).toInt()
    if (res != 0) return res
    if (dimenDp == 0) return 0
    if (dimenDp > 0) return 1
    return -1
}

fun DisplayMetrics.dp(dimenDp: Float): Int {
    val f = dimenDp * density
    val res = (f + 0.5f).toInt()
    if (res != 0) return res
    if (dimenDp == 0f) return 0
    if (dimenDp > 0) return 1
    return -1
}

fun DisplayMetrics.sp(dimenSp: Float): Float {
    return TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_SP, dimenSp, this)
}