package com.teslacoilsw.kotlin

import android.content.Intent
import com.android.launcher3.ItemInfo


fun Intent.getNumberExtraAsLong(key: String, defaultValue: Long): Long {
    return with(extras?.get(key)) {
        when (this) {
            is Long -> this
            is Int -> this.toLong()
            else -> defaultValue
        }
    }
}

fun Intent.isMainIntent(): Boolean {
    if (component == null || Intent.ACTION_MAIN != action ||
        categories?.size != 1 || !categories.contains(Intent.CATEGORY_LAUNCHER)) {
        return false
    }

    return extras?.isEmpty != false ||
            extras.size() == 1 && extras.containsKey(ItemInfo.EXTRA_PROFILE)
}
