package com.teslacoilsw.kotlin

import androidx.core.view.ViewCompat
import android.view.View
import android.view.ViewGroup

operator fun ViewGroup.get(index: Int): View? = getChildAt(index)
inline fun ViewGroup.forEach(action: (View) -> Unit) {
    for (index in 0 until childCount) {
        action(getChildAt(index))
    }
}

inline fun ViewGroup.forEachIndexed(action: (Int, View) -> Unit) {
    for (index in 0 until childCount) {
        action(index, getChildAt(index))
    }
}
operator fun ViewGroup.contains(child: View) = indexOfChild(child) != -1

val ViewGroup.size: Int
    get() = childCount

fun ViewGroup.children() = object : Iterable<View> {
    override fun iterator() = object : Iterator<View> {
        var index = 0
        override fun hasNext() = index < childCount
        override fun next() = getChildAt(index++)
    }
}

@Suppress("NOTHING_TO_INLINE")
inline fun View.isLayoutRtl() = ViewCompat.getLayoutDirection(this) == ViewCompat.LAYOUT_DIRECTION_RTL