package com.teslacoilsw.launcher.icontheme

import android.content.ComponentName
import android.content.ContentResolver
import android.content.Context
import android.graphics.Bitmap
import android.net.Uri
import com.android.launcher3.IconCache
import com.android.launcher3.LauncherAppState
import com.teslacoilsw.kotlin.tryCatch
import com.teslacoilsw.launcher.bitmaputils.BitmapUtils
import org.icontheme.api.ThemeConfig

class IconThemeOrgIconTheme(private val themeConfig: ThemeConfig) : IconTheme {
    override fun getThemedIconBitmap(context: Context, cache: IconCache, cn: ComponentName): Bitmap? {
        val d = themeConfig.getIconOrNull(context.contentResolver, cn) ?: return null
        return tryCatch(null) { BitmapUtils.getBitmap(d.loadDrawable(context), cache.fullResIconSize, cache.fullResIconSize, null) }
    }

    override fun getThemedIconFromBase(context: Context, cn: ComponentName, baseIcon: Bitmap): Bitmap? = null

    override val lastUpdateTime = 0L

    override val packageName: String
        get() = themeConfig.provider.authority

    override val calendarPackages: Array<String> = emptyArray()

    override fun canGenerateIcon(): Boolean = false

    override fun hasIconFor(cn: ComponentName): Boolean {
        return themeConfig.getIconOrNull(LauncherAppState.getInstance().context.contentResolver, cn) != null
    }

    fun getIcons(context: Context, contentResolver: ContentResolver, cn: ComponentName, size: Int): List<Bitmap> {
        return themeConfig.getIcons(contentResolver, cn).mapNotNull {
            BitmapUtils.getBitmap(it.loadDrawable(context), size, size, null)
        }
    }

    fun getObserverUri(): Uri {
        return Uri.parse("content://${themeConfig.provider.authority}/${themeConfig.id}")
    }
}