package com.teslacoilsw.launcher.onboarding

import android.content.Context
import android.content.pm.PackageManager
import android.os.Build

data class WizardOptions<T : WizardOption>(val default: T, val list: List<T>)

interface WizardOption {
    fun getLabel(context: Context): String
}

interface PermissionOption {
    val permissionRequestCode: Int
    val permissionsRequested: Array<out String>
    val permissionsRequired: Boolean
        get() = true

    fun hasPermissions(context: Context): Boolean {
        return if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M)
            permissionsRequested.all { context.checkSelfPermission(it) == PackageManager.PERMISSION_GRANTED }
        else
            true
    }
}