package com.teslacoilsw.launcher.preferences.fancyprefs

import android.content.Context
import android.util.AttributeSet
import android.view.Gravity
import android.view.View
import android.widget.FrameLayout
import androidx.core.content.res.use
import com.teslacoilsw.kotlin.dp
import com.teslacoilsw.kotlin.getThemeAttrColor
import com.teslacoilsw.launcher.R

class FancyPrefCardBorderView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null): FrameLayout(context, attrs) {

    init {
//        minimumHeight = context.dp(12)

        setBackgroundColor(context.getThemeAttrColor(R.attr.preferenceactivity_cardIdleBackground))
        //noinspection Recycle
        context.obtainStyledAttributes(attrs, R.styleable.FancyPrefCardBorderView).use { a ->
            if (a.getBoolean(R.styleable.FancyPrefCardBorderView_shadowAtTop, true)) {
                val v = View(context)
                v.setBackgroundResource(R.drawable.settings_card_shadow_bottom)
                val lp = LayoutParams(LayoutParams.MATCH_PARENT, context.dp(12))
                lp.gravity = Gravity.TOP
                addView(v, lp)
            }
            if (a.getBoolean(R.styleable.FancyPrefCardBorderView_shadowAtBottom, true)) {
                val v = View(context)
                v.setBackgroundResource(R.drawable.settings_card_shadow_top)
                val lp = LayoutParams(LayoutParams.MATCH_PARENT, context.dp(8))
                lp.gravity = Gravity.BOTTOM
                addView(v, lp)
            }
        }
    }

}