package com.teslacoilsw.launcher.preferences.fancyprefs

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import com.teslacoilsw.kotlin.dp
import com.teslacoilsw.launcher.R
import com.teslacoilsw.launcher.widget.NumberPicker

@SuppressLint("CustomViewStyleable")
class FancyPrefNumberPickerDialog @JvmOverloads
    constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0)
    : FancyPrefDialogView<Int>(context, attrs, defStyleAttr)
{
    val orientation: Int
    val format: String
    var min: Int
    var max: Int

    init {
        val a = context.obtainStyledAttributes(attrs, R.styleable.FancyPrefSeekBarView)
        try {
            orientation = a.getInt(R.styleable.FancyPrefSeekBarView_android_orientation, LinearLayout.HORIZONTAL)
            min = a.getInt(R.styleable.FancyPrefSeekBarView_min, 0)
            max = a.getInt(R.styleable.FancyPrefSeekBarView_max, 1)
            format = a.getString(R.styleable.FancyPrefSeekBarView_format)
        } finally {
            a.recycle()
        }

    }

    override fun bindDialogView(dialogView: View): (() -> Int)? {
        val picker = NumberPicker(context)
        picker.minValue = min
        picker.maxValue = max
        picker.value = value
        picker.wrapSelectorWheel = false
//        seekBar.format = format
        picker.orientation = orientation
        val end = context.dp(24)
        val start = context.dp(24)
        val top = context.dp(48)
        val bottom = context.dp(48)
        dialogView.setPaddingRelative(start, top, end, bottom)
//        dialogView.updatePaddingRelative(start = start, end = end)
        val lp = if (orientation == LinearLayout.VERTICAL)
            LayoutParams(context.dp(48), ViewGroup.LayoutParams.MATCH_PARENT)
        else
            LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, context.dp(48))

        (dialogView as ViewGroup).addView(picker, lp)

        return { picker.value }
    }
}