package com.teslacoilsw.launcher.preferences.fancyprefs

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import androidx.core.view.updatePaddingRelative
import com.teslacoilsw.kotlin.dp
import com.teslacoilsw.launcher.R

@SuppressLint("CustomViewStyleable")
class FancyPrefSeekBarDialog @JvmOverloads
    constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0)
    : FancyPrefDialogView<Int>(context, attrs, defStyleAttr)
{
    val orientation: Int
    val format: String
    var min: Int
    var max: Int

    init {
        val a = context.obtainStyledAttributes(attrs, R.styleable.FancyPrefSeekBarView)
        try {
            orientation = a.getInt(R.styleable.FancyPrefSeekBarView_android_orientation, LinearLayout.HORIZONTAL)
            min = a.getInt(R.styleable.FancyPrefSeekBarView_min, 0)
            max = a.getInt(R.styleable.FancyPrefSeekBarView_max, 1)
            format = a.getString(R.styleable.FancyPrefSeekBarView_format)
        } finally {
            a.recycle()
        }

    }

    override fun bindDialogView(dialogView: View): (() -> Int)? {
        val seekBar = FancyPrefSeekBarView(context)
        seekBar.min = min
        seekBar.max = max
        seekBar.progress = value
        seekBar.format = format
        val end = context.dp(24)
        val start = context.dp(9)
        dialogView.updatePaddingRelative(start = start, end = end)
        val lp = if (orientation == LinearLayout.VERTICAL)
            LayoutParams(LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.MATCH_PARENT)
        else
            LayoutParams(LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT)

        (dialogView as ViewGroup).addView(seekBar, lp)

        return { seekBar.progress }
    }
}