package com.teslacoilsw.launcher.preferences.fancyprefs

import com.teslacoilsw.launcher.preferences.Pref3
import rx.Observable


interface PrefHolder<T: Any> {
    var storedValue: T
    val asObservable: Observable<T>
}

class TransformPrefHolder<A: Any, B: Any>(val src: Pref3.Pref<B>, val toA: (B.() -> A), val toB: (A.() -> B)) : PrefHolder<A> {
    override var storedValue: A
        get() = src.value.toA()
        set(value) {
            src.value = value.toB()
        }
    override val asObservable: Observable<A>
        get() = src.asObservable.map { it.toA() }

    override fun toString(): String {
        return "TransformPrefHolder($src)"
    }
}
