package com.teslacoilsw.launcher.preferences.fancyprefs.color

import android.content.Context
import android.graphics.Color
import android.util.AttributeSet
import android.widget.Button

class ColorPickerButton(context: Context, attrs: AttributeSet) : Button(context, attrs) {

    private val colorBackground: ColorStateDrawable = ColorStateDrawable(resources, Color.BLACK)

    var color: Int
        get() = colorBackground.color
        set(color) {
            if (colorBackground.color != color) {
                colorBackground.color = color
                invalidate()
            }
        }

    init {
        background = colorBackground
    }


}
