package com.teslacoilsw.launcher.preferences.widget

import android.content.Context
import android.content.res.TypedArray
import android.util.AttributeSet
import android.view.ViewGroup
import android.widget.LinearLayout

open class MatchWrapLinearLayout @JvmOverloads
constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0, defStyleRes: Int = 0)
    : LinearLayout(context, attrs, defStyleAttr, defStyleRes)
{
    override fun generateLayoutParams(attrs: AttributeSet?): LayoutParams {
        return MatchWrapLayoutParams(context, attrs)
    }

}

class MatchWrapLayoutParams(context: Context, attrs: AttributeSet?) : LinearLayout.LayoutParams(context, attrs) {

    override fun setBaseAttributes(a: TypedArray, widthAttr: Int, heightAttr: Int) {
        if (a.hasValue(widthAttr))
            width = a.getLayoutDimension(widthAttr, "layout_width")
        else
            width = ViewGroup.LayoutParams.MATCH_PARENT
        if (a.hasValue(heightAttr))
            height = a.getLayoutDimension(heightAttr, "layout_height")
        else
            height = ViewGroup.LayoutParams.WRAP_CONTENT
    }
}