package com.teslacoilsw.launcher.preferences.widget

import android.content.Context
import android.graphics.Outline
import android.graphics.Rect
import android.util.AttributeSet
import android.view.View
import android.view.ViewOutlineProvider
import com.teslacoilsw.kotlin.dp

open class RoundRectView @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null) : View(context, attrs) {
    init {
        outlineProvider = object: ViewOutlineProvider() {
            override fun getOutline(view: View, outline: Outline) {
                outline.setRoundRect(Rect(0, 0, view.measuredWidth, view.measuredHeight), context.dp(8).toFloat())
            }
        }
        clipToOutline = true
    }

}