package com.teslacoilsw.launcher.preferences.widget

import android.content.Context
import android.util.AttributeSet
import android.view.MotionEvent
import com.teslacoilsw.matcompat.TintableSwitchCompat

class UserSwitchCompat @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null)
    : TintableSwitchCompat(context, attrs)
{
    var gettingUserInput = false

    override fun performClick(): Boolean {
        try {
            gettingUserInput = true
            return super.performClick()
        } finally {
            gettingUserInput = false
        }
    }

    override fun onTouchEvent(ev: MotionEvent): Boolean {
        try {
            gettingUserInput = true
            return super.onTouchEvent(ev)
        } finally {
            gettingUserInput = false
        }
    }

}