package com.teslacoilsw.launcher.util.StatusBar

import android.Manifest
import android.content.pm.PackageManager
import android.provider.Settings
import androidx.core.content.ContextCompat
import com.android.launcher3.LauncherAppState
import com.teslacoilsw.launcher.NovaLauncher
import com.teslacoilsw.launcher.util.BgHandler

private const val SYSUI_HIDDEN_BACK_BUTTON_TEXT = "key(4:content://)"
object HideBackButton {
    private var hasAdbPriv: Boolean? = null
    var hasHidden: Boolean = false
        private set
    var isHidden: Boolean = false
        private set

    fun hasAdbPriv(refresh: Boolean = false): Boolean {
        if (refresh || hasAdbPriv == null) {
            val context = LauncherAppState.getInstance().context
            hasAdbPriv = ContextCompat.checkSelfPermission(context, Manifest.permission.WRITE_SECURE_SETTINGS) == PackageManager.PERMISSION_GRANTED
        }
        return hasAdbPriv!!
    }

    private fun updateSysUiNavbar(launcher: NovaLauncher, includeBack: Boolean) {
        if (true)
            return
        if (hasAdbPriv()) {
            try {
                var navbar = Settings.Secure.getString(launcher.contentResolver, "sysui_nav_bar")
                navbar = if (includeBack)
                    navbar.replace(",$SYSUI_HIDDEN_BACK_BUTTON_TEXT[", ",back[")
                else
                    navbar.replace(",back[", ",$SYSUI_HIDDEN_BACK_BUTTON_TEXT[")
                Settings.Secure.putString(launcher.contentResolver, "sysui_nav_bar", navbar)
                if (!includeBack)
                    hasHidden = true
                isHidden = includeBack
            } catch (ex: Exception) {
                ex.printStackTrace()
            }
        }
    }

    fun post(handler: BgHandler, showBackButton: Boolean) {
        if (true)
            return
        if (showBackButton)
            handler.removeAndPostOne(hideBackButtonRunnable, showBackButtonRunnable)
        else
            handler.removeAndPostOne(showBackButtonRunnable, hideBackButtonRunnable)
    }

    private val hideBackButtonRunnable = Runnable { updateSysUiNavbar(NovaLauncher.getLauncher(), false) }
    private val showBackButtonRunnable = Runnable { updateSysUiNavbar(NovaLauncher.getLauncher(), true) }
}