package com.teslacoilsw.launcher.widget

import android.content.Context
import android.util.AttributeSet
import android.view.View
import android.view.ViewGroup

class Rotate90ParentView constructor(context: Context, attrs: AttributeSet? = null) : ViewGroup(context) {
    val child: View
        get() = getChildAt(0)

    init {
        clipChildren = false
    }

    constructor(child: View) : this(child.context) {
        addView(child)
        child.rotation = -90f
    }

    override fun onFinishInflate() {
        super.onFinishInflate()
        child.rotation = -90f
    }

    override fun onLayout(changed: Boolean, l: Int, t: Int, r: Int, b: Int) {
        val cx = width/2
        val cy = height/2
        val childWidth = child.measuredWidth
        val childHeight = child.measuredHeight

        val widthA = childWidth/2
        val widthB = childWidth - widthA
        val heightA = childHeight/2
        val heightB = childHeight - heightA
        child.layout(cx - widthA, cy - heightA, cx + widthB, cy + heightB)
    }

    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        child.measure(heightMeasureSpec, widthMeasureSpec)
        setMeasuredDimension(child.measuredHeight, child.measuredWidth)
    }
}